#ifndef BUNDLERNODE_H
#define BUNDLERNODE_H

#include <fugio/nodecontrolbase.h>
#include <fugio/osc/uuid.h>

class BundlerNode : public fugio::NodeControlBase
{
	Q_OBJECT

	Q_CLASSINFO( "Author", "Alex May" )
	Q_CLASSINFO( "Version", "1.0" )
	Q_CLASSINFO( "Description", "" )
	Q_CLASSINFO( "URL", FUGIO_WIKI_URL( "OSC_Bundler" ) )
	Q_CLASSINFO( "Contact", "http://www.bigfug.com/contact/" )

public:
	Q_INVOKABLE explicit BundlerNode( QSharedPointer<fugio::NodeInterface> pNode );

	virtual ~BundlerNode( void ) {}

	//-------------------------------------------------------------------------
	// NodeControlInterface

	virtual void inputsUpdated( qint64 pTimeStamp ) Q_DECL_OVERRIDE;

	virtual QList<QUuid> pinAddTypesInput() const Q_DECL_OVERRIDE;

	virtual bool canAcceptPin( fugio::PinInterface *pPin ) const Q_DECL_OVERRIDE;

private:
	static void addData( QByteArray &pBundle, const QByteArray &pPacket) ;
	static void buffer( QByteArray &pArray );

private:
	QSharedPointer<fugio::PinInterface>			 mPinInput;

	QSharedPointer<fugio::PinInterface>			 mPinOutput;
	fugio::VariantInterface						*mValOutput;
};


#endif // BUNDLERNODE_H
